
/**
 * Write a description of class ClockGUI here.
 * 
 * @author J. Icha
 * @version 16. 3. 2009
 */
import javax.swing.JFrame;
import javax.swing.JComboBox;
import javax.swing.Timer;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class ClockGUI extends JFrame
{
    // instance variables - replace the example below with your own
    private ClockDisplay clockDisplay;
    private JButton displayString;
    private Timer timer;
    private boolean restart = false;

    /**
     * Constructor for objects of class ClockGUI
     */
    public ClockGUI()
    {
        // initialise instance variables
        GregorianCalendar calendar = new GregorianCalendar();
        clockDisplay = new ClockDisplay( calendar.get(Calendar.HOUR_OF_DAY), calendar.get(Calendar.MINUTE),
                                                                         calendar.get(Calendar.SECOND));
        makeFrame();
    }

    /**
     * An example of a method - replace this comment with your own
     * 
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y 
     */
    private void makeFrame()
    {        
        int delay = 1000; //milliseconds
        ActionListener taskPerformer = new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                clockDisplay.timeTick();
                displayString.setText(clockDisplay.getTime());          
            } 
       };
       timer = new Timer(delay, taskPerformer);
       timer.start();      
       
        // put your code here
        setTitle("My New Clock");
        setLayout(new BorderLayout());
        JPanel clockPanel = new JPanel(new BorderLayout());       
        displayString = new JButton(clockDisplay.getTime());
        displayString.setEnabled(false);
//         displayString.setFocusable(false);
//         displayString.addActionListener(new ActionListener(){
//             public void actionPerformed(ActionEvent e){
//                 System.out.println("aaaaaaa");
//             }
//         });
        displayString.setBackground(Color.yellow);
        displayString.setFont(new Font("Serif", Font.BOLD, 48));        
        clockPanel.add(displayString);  
        add(clockPanel,BorderLayout.CENTER);
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(1,0));       
        JButton buttonStartStop = new JButton("Start/Stop");
        buttonStartStop.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                if(restart){
                    timer.restart();
                    restart = false;
                }
                else{
                    timer.stop();
                    restart = true;
                }                
//                 clockDisplay.timeTick();
//                 displayString.setText(clockDisplay.getTime());
//                 System.out.println("TTTTT");
            }
        });
        buttonPanel.add(buttonStartStop);
        
        final JComboBox comboBoxH = new JComboBox();
        for(int i = 0; i <  24;i++ ){
            comboBoxH.addItem(i);
        };
        comboBoxH.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
               Object hour = comboBoxH.getSelectedItem();
               int h = ((Integer)hour).intValue();
                int[] timeHMS = clockDisplay.getHMS(); 
//                 int limit = clockDisplay.getLimitH();
                clockDisplay.setTime(h, timeHMS[1], timeHMS[2]);                
                displayString.setText(clockDisplay.getTime());
//                 System.out.println("HHHHHH");
            }
        });
        buttonPanel.add(comboBoxH);
        
        JButton buttonSetM = new JButton("Set Minute");
        buttonSetM.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                int[] timeHMS = clockDisplay.getHMS(); 
                int limit = clockDisplay.getLimitMaS();
                clockDisplay.setTime(timeHMS[0], ++timeHMS[1]%limit, timeHMS[2]);
                displayString.setText(clockDisplay.getTime());
//                 System.out.println("MMMMMM");
            }
        });
        buttonPanel.add(buttonSetM);
        
        JButton buttonSetS = new JButton("Set Second");
        buttonSetS.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                int[] timeHMS = clockDisplay.getHMS();
                int limit = clockDisplay.getLimitMaS();
                clockDisplay.setTime(timeHMS[0], timeHMS[1], ++timeHMS[2]%limit);
                displayString.setText(clockDisplay.getTime());
//                 System.out.println("SSSSSS");
            }
        });
        buttonPanel.add(buttonSetS);
        
        JPanel bPanel = new JPanel();
        bPanel.setBackground(Color.blue);
        bPanel.add(buttonPanel);
        
        add(bPanel, BorderLayout.SOUTH);
        
        pack();
        setVisible(true);
    }
}
