/**
   A frame containing a panel for testing mouse operations
*/
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JMenuItem;
import java.awt.Toolkit;
import java.awt.event.*;
import javax.swing.KeyStroke;

public class MouseFrame extends JFrame
{
   public MouseFrame()
   {
      setTitle("MouseTest");
      setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);

      // add panel to frame

      MousePanel panel = new MousePanel();
      add(panel);
      makeMenuBar(panel);
   }
   
   
   private void makeMenuBar(final MousePanel panel)
    {
        final int SHORTCUT_MASK =
            Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();


        JMenuBar menubar = new JMenuBar();
        setJMenuBar(menubar);
        
        JMenu menu;
        JMenuItem item;
        
        // create the File menu
        menu = new JMenu("Panel");
        menubar.add(menu);
        
        item = new JMenuItem("Clear");
            item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, SHORTCUT_MASK));
            item.addActionListener(new ActionListener() {
                               public void actionPerformed(ActionEvent e) { panel.clear(); }
                           });
        menu.add(item);

//         item = new JMenuItem("Close");
//             item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, SHORTCUT_MASK));
//             item.addActionListener(new ActionListener() {
//                                public void actionPerformed(ActionEvent e) { close(); }
//                            });
//         menu.add(item);
//         menu.addSeparator();
//         
//         item = new JMenuItem("Quit");
//             item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, SHORTCUT_MASK));
//             item.addActionListener(new ActionListener() {
//                                public void actionPerformed(ActionEvent e) { quit(); }
//                            });
//         menu.add(item);
// 
// 
//         // create the Filter menu
//         menu = new JMenu("Filter");
//         menubar.add(menu);
//         
//         item = new JMenuItem("Darker");
//             item.addActionListener(new ActionListener() {
//                                public void actionPerformed(ActionEvent e) { makeDarker(); }
//                            });
//         menu.add(item);
// 
//         item = new JMenuItem("Lighter");
//             item.addActionListener(new ActionListener() {
//                                public void actionPerformed(ActionEvent e) { makeLighter(); }
//                            });
//         menu.add(item);
// 
//         item = new JMenuItem("Threshold");
//             item.addActionListener(new ActionListener() {
//                                public void actionPerformed(ActionEvent e) { threshold(); }
//                            });
//         menu.add(item);
// 
//         // create the Help menu
//         menu = new JMenu("Help");
//         menubar.add(menu);
//         
//         item = new JMenuItem("About ImageViewer...");
//             item.addActionListener(new ActionListener() {
//                                public void actionPerformed(ActionEvent e) { showAbout(); }
//                            });
//         menu.add(item);

    }

   public static final int DEFAULT_WIDTH = 500;
   public static final int DEFAULT_HEIGHT = 500;  
}